#ifndef RB_H_
#define RB_H_

#include <limits.h>
#include <setjmp.h>

// --------------------[ Red-Black Tree ]---------------------------

typedef enum { RED=0, BLACK=1 } Colors ;

typedef struct _node
{
#if 0
    vwLock _POLock ;      // Embedded PO lockword
#endif

    intptr_t k ;
    intptr_t v ;
    struct _node * p ;
    struct _node * l ;
    struct _node * r ;
    intptr_t c ;
//    struct _node * NextFree ;

    // Avoid false-sharing but at the expense of DTLB and D$ pressure.
    vwLock Pad [6] ;
}
node_t ;

typedef struct
{        // KVMap
    double padA [16] ;
    node_t * root ;
    double pad [16] ;
}
set_t ;


typedef set_t KVMap ;

// Key-Value "map" interface to underlying implementation:

extern int kv_insert(Thread * Self, KVMap * sk, int Key, int Valu);
extern int kv_delete(Thread * Self, KVMap * sk, int key);
extern int kv_put (Thread * Self, KVMap * sk, int Key, int Valu) ;
extern int kv_set (Thread * Self, KVMap * sk, int Key, int Valu) ;
extern int kv_get (Thread * Self, KVMap * sk, int Key) ;
extern int kv_contains (Thread * Self, KVMap * sk, int Key) ;
extern void kv_init();
extern int kv_verify (KVMap * sk, int Verbose) ;
extern KVMap * kv_create () ;



#endif /*RB_H_*/
