
#ifndef TRACELOG_H_
#define TRACELOG_H_

#include <inttypes.h>

//#define ENABLE_TRACE

// ----------------------------

typedef enum _TraceEventName { _tl_txstart, _tl_txabort, _tl_txcommit, _tl_sigsegf, _tl_rscoherent, _tl_txload, _tl_txvfy, _tl_txstore, _tl_txsterilize, _tl_LK_ldlock, _tl_LK_stlock, _tl_LK_caslock, _tl_LK_ldaddr, _tl_LK_staddr, _tl_kv_get, _tl_kv_put, _tl_kv_delete }TraceEventName ;

#ifdef ENABLE_TRACE

inline void TraceEvent(int thread_id, int step, enum _TraceEventName type, intptr_t const volatile *a, intptr_t arg1, intptr_t arg2);
inline void TraceTxStart(int thread_id, int step, vwLock rv);
inline void TraceTxCommit(int thread_id, int step);
inline void TraceTxAbort(int thread_id, int step);
inline void TraceTxLoad(int thread_id, int step, intptr_t const volatile * addr);
inline void TraceTxStore(int thread_id, int step, intptr_t const volatile * addr, intptr_t val);
inline void TraceTxSterilize(int thread_id, int step, intptr_t const volatile * addr);
inline void TraceSIGSEGF(int thread_id, int step, intptr_t const volatile * addr);
inline void TraceRSCoherent(int thread_id, int step, intptr_t const volatile * addr, intptr_t val);
void PrintTrace();
void TraceInit();


#else

#define TraceEvent(...)
#define TraceTxStart(...)
#define TraceTxCommit(...)
#define TraceTxAbort(...)
#define TraceTxLoad(...)
#define TraceTxStore(...)
#define TraceTxSterilize(...)
#define TraceSIGSEGF(...)
#define TraceRSCoherent(...)
#define PrintTrace(...)
#define TraceInit(...)

#endif

#endif
